package cn.com.ctop.kuaishou.modules.ai.service.impl;

import cn.com.ctop.common.module.entity.CtopOauthToken;
import cn.com.ctop.common.module.entity.MaterialCutFrame;
import cn.com.ctop.common.module.service.ICtopOauthTokenService;
import cn.com.ctop.common.module.service.IMaterialCutFrameService;
import cn.com.ctop.common.module.utils.Check;
import cn.com.ctop.common.module.utils.HttpUtils;
import cn.com.ctop.common.module.utils.KuaishouInterfaceConstant;
import cn.com.ctop.common.module.utils.PropertiesUtils;
import cn.com.ctop.kuaishou.modules.ai.entity.AiKuaiShouAppInfo;
import cn.com.ctop.kuaishou.modules.ai.entity.AiKuaishouCampaignLevelOperationRecord;
import cn.com.ctop.kuaishou.modules.ai.entity.AiKuaishouCreativeLevelOperationRecord;
import cn.com.ctop.kuaishou.modules.ai.entity.AiKuaishouUnitLevelOperationRecord;
import cn.com.ctop.kuaishou.modules.ai.entity.KuaiShouAppMultipleBids;
import cn.com.ctop.kuaishou.modules.ai.entity.KuaishouAccountCreativeOverrunInfo;
import cn.com.ctop.kuaishou.modules.ai.entity.KuaishouDirectionalPackage;
import cn.com.ctop.kuaishou.modules.ai.entity.KuaishouProjectStrategy;
import cn.com.ctop.kuaishou.modules.ai.entity.KuaishouVideoDirectionalPackage;
import cn.com.ctop.kuaishou.modules.ai.enums.KuaishouCreativeAdsenceTypeEnum;
import cn.com.ctop.kuaishou.modules.ai.enums.KuaishouCreativeMatTypeEnum;
import cn.com.ctop.kuaishou.modules.ai.mapper.KuaishouVideoDirectionalPackageMapper;
import cn.com.ctop.kuaishou.modules.ai.service.IAiKuaiShouAppInfoService;
import cn.com.ctop.kuaishou.modules.ai.service.IAiKuaishouCampaignLevelOperationRecordService;
import cn.com.ctop.kuaishou.modules.ai.service.IAiKuaishouCreativeLevelOperationRecordService;
import cn.com.ctop.kuaishou.modules.ai.service.IAiKuaishouProjectCreateCreativeService;
import cn.com.ctop.kuaishou.modules.ai.service.IAiKuaishouUnitLevelOperationRecordService;
import cn.com.ctop.kuaishou.modules.ai.service.IKuaiShouAppMultipleBidsService;
import cn.com.ctop.kuaishou.modules.ai.service.IKuaishouAccountCreativeOverrunInfoService;
import cn.com.ctop.kuaishou.modules.ai.service.IKuaishouDirectionalPackageService;
import cn.com.ctop.kuaishou.modules.ai.service.IKuaishouLandpagePackageService;
import cn.com.ctop.kuaishou.modules.batch.entity.KuaiShouAppList;
import cn.com.ctop.kuaishou.modules.batch.entity.KuaiShouImageGet;
import cn.com.ctop.kuaishou.modules.batch.entity.KuaiShouVideoGet;
import cn.com.ctop.kuaishou.modules.batch.entity.KuaishouTemplateTarget;
import cn.com.ctop.kuaishou.modules.batch.mapper.KuaishouTemplateTargetMapper;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouAppListService;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouCampaignService;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouGroupService;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouGroupTemplateService;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouImageGetService;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouMaterialUploadService;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouUpdateService;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouVideoGetService;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaishouInterfaceService;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.google.common.collect.Lists;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.util.DateUtils;
import org.jeecg.common.util.RedisUtil;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.UUID;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@Slf4j
@Service
public class AiKuaishouProjectCreateCreativeServiceImpl implements IAiKuaishouProjectCreateCreativeService {
    @Autowired
    private IKuaiShouGroupService groupService;
    @Autowired
    private IKuaiShouGroupTemplateService groupTemplateService;
    @Autowired
    private ICtopOauthTokenService tokenService;
    @Autowired
    private IKuaishouInterfaceService kuaishouInterfaceService;
    @Autowired
    private IKuaiShouVideoGetService videoGetService;
    @Autowired
    private IMaterialCutFrameService materialCutFrameService;
    @Autowired
    private IKuaiShouImageGetService imageGetService;
    @Autowired
    private IKuaiShouMaterialUploadService materialUploadService;
    @Autowired
    private IKuaishouAccountCreativeOverrunInfoService overrunInfoService;
    @Autowired
    private IAiKuaishouCampaignLevelOperationRecordService aiKuaishouCampaignLevelOperationRecordService;
    @Autowired
    private IAiKuaiShouAppInfoService appInfoService;
    @Autowired
    private IAiKuaishouUnitLevelOperationRecordService unitLevelOperationRecordService;
    @Autowired
    private IAiKuaishouCreativeLevelOperationRecordService creativeLevelOperationRecordService;
    @Autowired
    private IKuaishouLandpagePackageService landpagePackageService;
    @Autowired
    private IKuaiShouAppMultipleBidsService kuaiShouAppMultipleBidsService;
    @Autowired
    private KuaishouVideoDirectionalPackageMapper packageMapper;
    @Autowired
    private IKuaishouDirectionalPackageService directionalPackageService;

    static ExecutorService executorService = Executors.newFixedThreadPool(2);

    /**
     * 项目自动创建
     *
     * @return void
     */
    @Override
    public void projectAutomaticCreates(KuaishouProjectStrategy strategy) {
        //自定义组数，最多540
        Integer customUnitCnt = strategy.getCustomUnitCnt();
        if (Check.isNull(customUnitCnt)) {
            Integer imageCnt = strategy.getImageCnt();
            if (imageCnt <= 1) {
                customUnitCnt = 600;
            } else {
                customUnitCnt = 2000 / imageCnt;
            }
        }
        //程序化组数 最大60
        Integer programUnitCnt = strategy.getProgramUnitCnt();
        if (Check.isNull(programUnitCnt)) {
            Integer imageCnt = strategy.getImageCnt();
            if (imageCnt <= 1) {
                programUnitCnt = 60;
            } else {
                programUnitCnt = 300 / imageCnt;
            }
        }
        //素材来源 1-上新素材，2-高质量素材，3-遗漏素材，4-历史打捞
        List<Integer> sourceMaterial = JSONObject.parseObject(strategy.getSourceMaterial(), List.class);
        //创意制作方式，0-不限，4-自定义,7-程序化创意
        for (Integer createType : sourceMaterial) {
            if (strategy.getUnitType() == 4) {
                this.autoCreateCreative(strategy, createType, customUnitCnt);
            } else if (strategy.getUnitType() == 7) {
                this.autoCreateProgramCreative(strategy, createType, programUnitCnt);
            } else {
                this.autoCreateProgramCreative(strategy, createType, programUnitCnt);
                this.autoCreateCreative(strategy, createType, customUnitCnt);
            }
        }
    }

    /**
     * 创建自定义创意
     *
     * @param strategy   账户配置信息
     * @param createType 创意创建类型 1:素材上新 2：历史高质量 3:历史遗漏素材 4:历史打捞
     * @param videoCnt   视频数量
     */
    private Integer autoCreateCreative(KuaishouProjectStrategy strategy, Integer createType, Integer videoCnt) {
        String strategyUuid = UUID.randomUUID().toString();
        Long accountId = strategy.getAccountId();
        CtopOauthToken token = tokenService.getOauthTokenByAccountId(accountId.toString());
        if (null == token) {
            log.info("token获取失败=>accountId:{}", accountId);
            return videoCnt;
        }
        //1:获取视频信息
        kuaishouInterfaceService.getVideoList(token, DateUtils.date2Str(), DateUtils.date2Str());
        Long timeStart = KuaishouCreativeMatTypeEnum.getStartTimeByType(strategy.getUnitType().toString() + createType.toString());
        Long timeEnd = KuaishouCreativeMatTypeEnum.getEndTimeByType(strategy.getUnitType().toString() + createType.toString());
        Long now = System.currentTimeMillis();
        String startTime = DateUtils.formatDateTime(now + timeStart * 60 * 1000L);
        String endTime = DateUtils.formatDateTime(now + timeEnd * 60 * 1000L);

        Integer singleAppid = strategy.getSingleAppid();
        //单/多应用，1单应用，2多应用
        if (null != singleAppid && singleAppid == 1) {
            //单一应用
            String replaceString = KuaishouCreativeMatTypeEnum.getNameByType(strategy.getUnitType().toString() + createType.toString());
            List<KuaiShouVideoGet> newVideos = getVideosByParams(strategy, startTime, endTime, null, createType, Long.valueOf(videoCnt));
            if (null == newVideos || newVideos.isEmpty()) {
                log.info("账户：{}，{} 到 {} 未获取到相应素材({})", accountId, startTime, endTime, replaceString);
                return videoCnt;
            }
            Long appId = null;
            //appId，当计划类型为2时必填
            if (strategy.getCampaignType() == 2 || strategy.getCampaignType() == 7) {
                appId = Check.isNull(strategy.getAppId()) ? JSONArray.parseArray(strategy.getAppIdArray()).getLong(0) : strategy.getAppId();
                if (Check.isNull(appId)) {
                    return videoCnt;
                }
            }
            Long newCampaignId = getCampaignId(strategy, token, replaceString, "TODAY", createType, appId, strategyUuid);
            if (null == newCampaignId) {
                return videoCnt;
            }
            //3、在“上新”计划中新增广告组，一个素材搭配n张封面，组成一个广告组
            for (KuaiShouVideoGet videoItem : newVideos) {
                Boolean unitOverrun = getUnitOverrun(accountId.toString());
                if (unitOverrun) {
                    log.error("组创建超限,accountId:{}", accountId);
                    return 0;
                }
                //快手账户创意创建超限记录信息，查到数据则说明已经超限
                KuaishouAccountCreativeOverrunInfo overrunInfo = overrunInfoService.getByParams(accountId, DateUtils.formatDate(new Date()));
                if (null != overrunInfo) {
                    return 0;
                }
                // 每个组，搭配5个创意
                List<MaterialCutFrame> cutFrameList = materialCutFrameService.getListByVideoSignature(videoItem.getSignature());
                if ((null == cutFrameList || cutFrameList.isEmpty())) {
                    log.info("未获取到视频封面=>videoSignature:{}", videoItem.getSignature());
                    continue;
                }
                String unitName = getName(strategy.getGroupName(), strategy, createType, videoItem.getPhotoName(), "unit", newCampaignId, appId, videoItem.getMaterialType());
                JSONObject unitParams = createUnitParams(token, newCampaignId, strategy, unitName, appId, videoItem);
                log.info("创建广告组入参：{}", unitParams);
                Map<String, Object> unitCreateResult = kuaishouInterfaceService.adUnitCreate(token.getAccessToken(), token.getAccountId(), unitParams, 1);
                Integer unitCode = (Integer) unitCreateResult.get("code");
                String unitMessage = (String) unitCreateResult.get("message");
                AiKuaishouUnitLevelOperationRecord unitLevelOperationRecord = new AiKuaishouUnitLevelOperationRecord();
                BeanUtils.copyProperties(strategy, unitLevelOperationRecord);
                unitLevelOperationRecord.setGroupName(unitName);
                unitLevelOperationRecord.setCampaignId(newCampaignId);
                unitLevelOperationRecord.setCpaBid(unitParams.getInteger("cpa_bid"));
                unitLevelOperationRecord.setBid(unitParams.getInteger("bid"));
                unitLevelOperationRecord.setDeepConversionBid(unitParams.getInteger("deep_conversion_bid"));
                unitLevelOperationRecord.setCreateTime(new Date());
                unitLevelOperationRecord.setStatus(unitCode);
                unitLevelOperationRecord.setMessage(unitMessage);
                unitLevelOperationRecord.setCampaignId(newCampaignId);
                unitLevelOperationRecord.setAiStrategyUuid(strategyUuid);
                unitLevelOperationRecord.setCreateType(2);//项目创建
                if (unitCode != 0) {
                    log.info("组创建失败=>accountId:{};message:{}", accountId, unitMessage);
                    unitLevelOperationRecordService.saveOrUpdate(unitLevelOperationRecord);
                    continue;
                }
                Long unitId = (Long) unitCreateResult.get("unitId");
                unitLevelOperationRecord.setUnitId(unitId);
                unitLevelOperationRecordService.saveOrUpdate(unitLevelOperationRecord);
                videoCnt--;
                JSONObject creativeParams = creativeParams(token, unitId, videoItem, strategy);
                createCreativeByImage(cutFrameList, token, creativeParams, newCampaignId, unitId, videoItem, strategy.getImageCnt(), strategy, strategyUuid, null);
                if (videoCnt <= 0) {
                    return 0;
                }
            }
        }
        return videoCnt;
    }

    /**
     * 创建程序化创意
     *
     * @param strategy
     */
    public void autoCreateProgramCreative(KuaishouProjectStrategy strategy, Integer createType, Integer videoCnt) {
        String strategyUuid = UUID.randomUUID().toString();
        strategy.setUnitType(7);
        Long accountId = strategy.getAccountId();
        CtopOauthToken token = tokenService.getOauthTokenByAccountId(accountId.toString());
        if (null == token) {
            log.info("token获取失败=>accountId:{}", accountId);
            return;
        }
        //1:获取视频信息
        kuaishouInterfaceService.getVideoList(token, DateUtils.date2Str(), DateUtils.date2Str());
        //2:判定账户是否单一应用
        Long timeStart = null;
        Long timeEnd = null;
        Integer singleAppid = strategy.getSingleAppid();
        if (null != singleAppid && singleAppid == 0) {
            timeStart = -7 * 60 * 24L;
            timeEnd = -5L;
        } else {
            timeStart = KuaishouCreativeMatTypeEnum.getStartTimeByType(strategy.getUnitType().toString() + createType.toString());
            timeEnd = KuaishouCreativeMatTypeEnum.getEndTimeByType(strategy.getUnitType().toString() + createType.toString());
        }
        Long now = System.currentTimeMillis();
        String startTime = DateUtils.formatDateTime(now + timeStart * 60 * 1000L);
        String endTime = DateUtils.formatDateTime(now + timeEnd * 60 * 1000L);
        String nowDate = DateUtils.getNowDate("yyyy-MM-dd");
        String key = token.getAccountId() + "_ProgramCreative" + "_" + nowDate;

        //单/多应用，1单应用，2多应用
        if (null != singleAppid && singleAppid == 1) {
            String replaceString = KuaishouCreativeMatTypeEnum.getNameByType(strategy.getUnitType().toString() + createType.toString());
            //单一应用
            List<KuaiShouVideoGet> allVideos = getVideosByParams(strategy, startTime, endTime, null, createType, Long.valueOf(videoCnt));
            if (null == allVideos) {
                return;
            }
            Long appId = null;
            //appId，当计划类型为2时必填
            if (strategy.getCampaignType() == 2 || strategy.getCampaignType() == 7) {
                appId = Check.isNull(strategy.getAppId()) ? JSONArray.parseArray(strategy.getAppIdArray()).getLong(0) : strategy.getAppId();
                if (Check.isNull(appId)) {
                    return;
                }
            }
            Long newCampaignId = getCampaignId(strategy, token, replaceString, "TODAY", createType, appId, strategyUuid);
            if (null == newCampaignId) {
                return;
            }
            //创意
            List<List<KuaiShouVideoGet>> splitVideos = Lists.partition(allVideos, 5);
            for (int j = 1; j < splitVideos.size() + 1; j++) {
                Boolean unitOverrun = getUnitOverrun(accountId.toString());
                if (unitOverrun) {
                    log.error("组创建超限,accountId:{}", accountId);
                    return;
                }

                Object redisObj = redisUtil.get(key);
                if (!Check.isNull(redisObj)) {
                    Integer value = (Integer) redisObj;
                    if (value == 1) {
                        log.error("程序化创意创建超限,accountId:{}", strategy.getAccountId());
                        return;
                    }
                }
                //创建组
                String unitName = getName(strategy.getGroupName(), strategy, createType, null, "unit", newCampaignId, appId, null);
                JSONObject unitParams = createUnitParams(token, newCampaignId, strategy, unitName, appId, null);
                log.info("创建广告组入参：{}", unitParams);
                Map<String, Object> unitCreateResult = kuaishouInterfaceService.adUnitCreate(token.getAccessToken(), token.getAccountId(), unitParams, 1);
                Integer unitCode = (Integer) unitCreateResult.get("code");
                String unitMessage = (String) unitCreateResult.get("message");
                AiKuaishouUnitLevelOperationRecord unitLevelOperationRecord = new AiKuaishouUnitLevelOperationRecord();
                BeanUtils.copyProperties(strategy, unitLevelOperationRecord);
                unitLevelOperationRecord.setGroupName(unitName);
                unitLevelOperationRecord.setCampaignId(newCampaignId);
                unitLevelOperationRecord.setCpaBid(unitParams.getInteger("cpa_bid"));
                unitLevelOperationRecord.setBid(unitParams.getInteger("bid"));
                unitLevelOperationRecord.setDeepConversionBid(unitParams.getInteger("deep_conversion_bid"));
                unitLevelOperationRecord.setCreateTime(new Date());
                unitLevelOperationRecord.setStatus(unitCode);
                unitLevelOperationRecord.setMessage(unitMessage);
                unitLevelOperationRecord.setCampaignId(newCampaignId);
                unitLevelOperationRecord.setAiStrategyUuid(strategyUuid);
                unitLevelOperationRecord.setCreateType(2);//项目创建
                if (unitCode != 0) {
                    log.info("组创建失败=>accountId:{};message:{}", accountId, unitMessage);
                    unitLevelOperationRecordService.saveOrUpdate(unitLevelOperationRecord);
                    return;
                }
                Long unitId = (Long) unitCreateResult.get("unitId");
                unitLevelOperationRecord.setUnitId(unitId);
                unitLevelOperationRecordService.saveOrUpdate(unitLevelOperationRecord);
                JSONObject creativeParams = programCreativeParams(token, unitId, splitVideos.get(j - 1), strategy, j, null);
                createProgramCreative(token, creativeParams, strategy);
            }
        }

    }

    @Override
    public void customCreativeSupplement(KuaishouProjectStrategy strategy, Integer hour) {
        Integer customUnitCnt = strategy.getCustomUnitCnt();
        if (Check.isNull(customUnitCnt)) {
            Integer imageCnt = strategy.getImageCnt();
            if (imageCnt <= 1) {
                customUnitCnt = 600;
            } else {
                customUnitCnt = 2000 / imageCnt;
            }
        }

        Integer unitNum = customUnitCnt * hour / 20;
        log.info("{}当前时间内需要创建组总数：{}", strategy.getAccountId(), unitNum);
        //查询当前账户创建自定义类型组数量
        int unitCreateCnt = groupService.queryToDayBuiltCount(strategy.getAccountId());
        log.info("{}截止目前创建组总数：{}", strategy.getAccountId(), unitCreateCnt);
        Integer remindCnt = unitNum - unitCreateCnt;
        if (remindCnt >= 1) {
            log.info("{}组创建不足，剩余需要创建个数{},使用历史遗漏素材创建", strategy.getAccountId(), remindCnt);
            //优先创建历史遗漏素材
            remindCnt = this.autoCreateCreative(strategy, 3, remindCnt);
        }
        if (remindCnt >= 1) {
            log.info("{}组创建不足，剩余需要创建个数{},使用高质量素材创建", strategy.getAccountId(), remindCnt);
            //高质量素材
            remindCnt = this.autoCreateCreative(strategy, 2, remindCnt);
        }
        if (remindCnt >= 1) {
            //历史打捞素材
            log.info("{}组创建不足，剩余需要创建个数{},使用历史打捞素材创建", strategy.getAccountId(), remindCnt);
            this.autoCreateCreative(strategy, 4, remindCnt);
        }
    }

    @Override
    public void customCreativeLimit(KuaishouProjectStrategy strategy) {
        Integer unitNum = strategy.getCustomUnitCnt();
        if (Check.isNull(unitNum)) {
            Integer imageCnt = strategy.getImageCnt();
            if (imageCnt <= 1) {
                unitNum = 600;
            } else {
                unitNum = 2000 / imageCnt;
            }
        }
        log.info("{}当天可创建组总数：{}", strategy.getAccountId(), unitNum);
        //查询当前账户创建自定义类型组数量
        int unitCreateCnt = groupService.queryToDayBuiltCount(strategy.getAccountId());
        log.info("{}截止目前创建组总数：{}", strategy.getAccountId(), unitCreateCnt);
        Integer remindCnt = unitNum - unitCreateCnt;
        if (remindCnt >= 1) {
            log.info("{}组创建不足，剩余需要创建个数{},开始上新素材创建", strategy.getAccountId(), remindCnt);
            this.autoCreateCreative(strategy, 1, remindCnt);
        }
    }

    @Autowired
    private IKuaiShouUpdateService updateService;

    private void createProgramCreative(CtopOauthToken token, JSONObject creativeParams, KuaishouProjectStrategy strategy) {
        Map<String, String> headers = new HashMap<>();
        headers.put("Content-Type", "application/json");
        headers.put("Access-Token", token.getAccessToken());
        String url = PropertiesUtils.getConfig("kuaishou_api_url") + KuaishouInterfaceConstant.PROGRAM_CREATE;
        String result = HttpUtils.kuaiShouhttpPostRequest(url, creativeParams.toJSONString(), headers);
        JSONObject resultJson = JSON.parseObject(result);
        log.info("创建程序化创意返回结果：{}", resultJson);
        if (Check.isNull(resultJson)) {
            log.error("程序化创意创意异常：api接口返回为空");
            return;
        }
        Integer code = resultJson.getInteger("code");
        String message = resultJson.getString("message");
        Long unitId = creativeParams.getLong("unit_id");
        if (code == 0) {
            createLandPageAndUnit(creativeParams, resultJson.getJSONObject("data"));
            log.info("创建程序化创意成功，accountId：{}，unit：{}", token.getAccountId(), unitId);
        } else {
            log.error("快手创建程序化创意失败，accountId:{},unitId:{}，返回信息:{}", token.getAccountId(), unitId, message);
            if (code == 400001 && "/rest/openapi/v2/creative/advanced/program/create调用已超日限，次日可恢复调用".equals(message)) {
                String nowDate = DateUtils.getNowDate("yyyy-MM-dd");
                String key = token.getAccountId() + "_ProgramCreative" + "_" + nowDate;
                redisUtil.set(key, 1, 100000L);
                updateService.updateUnitStatus(token.getAccessToken(), token.getAccountId(), unitId, 3, "e9ca23d68d884d4ebb19d07889727dae");
            }
        }
    }

    //绑定落地页与广告组、创意的关系
    private void createLandPageAndUnit(JSONObject programJson, JSONObject data) {
        if (!Check.isNull(data) && !Check.isNull(programJson.getLong("site_id"))) {
            Thread thread = new Thread() {
                @Override
                public void run() {
                    landpagePackageService.createLandPageAndUnit(programJson.getLong("site_id"), data.getLong("creative_id"), programJson.getLong("unit_id"), programJson.getLong("advertiser_id"));
                }
            };
            thread.start();
        }
    }

    private JSONObject programCreativeParams(CtopOauthToken token, Long unitId, List<KuaiShouVideoGet> list, KuaishouProjectStrategy strategy, Integer creativeCnt, String appVersion) {
        JSONObject programJson = new JSONObject();
        programJson.put("advertiser_id", token.getAccountId());
        programJson.put("unit_id", unitId);
        if (strategy.getSingleAppid() != null && strategy.getSingleAppid() == 0) {  // 多应用情况下 创意名称已app-versionMI命名
            if (!Check.isNull(appVersion)) {
                programJson.put("package_name", appVersion);
            } else {
                programJson.put("package_name", "程序化创意" + creativeCnt);
            }

        } else {
            programJson.put("package_name", "程序化创意" + creativeCnt);
        }

        JSONArray horizontalPhotoIds = new JSONArray();
        JSONArray verticalPhotoIds = new JSONArray();
        JSONArray coverImageTokens = new JSONArray();
        for (KuaiShouVideoGet videoGet : list) {
            List<MaterialCutFrame> cutFrameList = materialCutFrameService.getListByVideoSignature(videoGet.getSignature());
            if (!Check.isNull(cutFrameList)) {
                MaterialCutFrame cutFrame = cutFrameList.get(0);
                String imageToken = getImageToken(cutFrame.getUrl(), cutFrame.getSignature(), token.getAccountId(), token.getAccessToken());
                if (!Check.isNull(imageToken)) {
                    coverImageTokens.add(imageToken);
                }
            }
            if (videoGet.getMaterialType() == 2) {
                horizontalPhotoIds.add(videoGet.getPhotoId());
            }
            if (videoGet.getMaterialType() == 1) {
                verticalPhotoIds.add(videoGet.getPhotoId());
            }
        }
        programJson.put("horizontal_photo_ids", horizontalPhotoIds);
        programJson.put("vertical_photo_ids", verticalPhotoIds);
        if (coverImageTokens.size() >= 5) {
            coverImageTokens.remove(0);
        }
        programJson.put("cover_image_tokens", coverImageTokens);

        if (!Check.isNull(strategy.getSiteId())) {
            programJson.put("site_id", strategy.getSiteId());
        }
        if (!Check.isNull(strategy.getStickerTitle())) {
            programJson.put("sticker_styles", strategy.getStickerTitle());
        }

        if (!Check.isNull(strategy.getActionBarText())) {
            programJson.put("action_bar", strategy.getActionBarText());
        }
        if (!Check.isNull(strategy.getClickTrackUrl())) {
            programJson.put("click_url", strategy.getClickTrackUrl());
        }
        if (!Check.isNull(strategy.getActionbarClickUrl())) {
            programJson.put("actionbar_click_url", strategy.getActionbarClickUrl());
        }

        JSONArray captions = getCaptions(strategy.getDescription());
        programJson.put("captions", captions);
        if (!Check.isNull(strategy.getCreativeCategory())) {
            programJson.put("creative_category", strategy.getCreativeCategory());
            programJson.put("creative_tag", JSON.parseArray(strategy.getCreativeTag()));
        }
        return programJson;
    }

    private JSONArray getCaptions(String description) {
        JSONArray jsonArray = JSONArray.parseArray(description);
        if (jsonArray.size() <= 3) {
            return jsonArray;
        }
        Collections.shuffle(jsonArray);
        JSONArray captions = new JSONArray();
        for (int i = 0; i < jsonArray.size(); i++) {
            captions.add(jsonArray.getString(i));
            if (captions.size() == 3) {
                break;
            }
        }
        return captions;
    }

    private List<KuaiShouVideoGet> getNewVideoListByParams(KuaishouProjectStrategy strategy, String startTime, String endTime, AiKuaiShouAppInfo appInfo) {
        if (null == appInfo) {
            return videoGetService.getNewVideoBetweenTime(strategy.getAccountId(), startTime, endTime, strategy.getChannelType(), null, null);
        } else {
            //查询通用素材
            List<KuaiShouVideoGet> generalVideos = new ArrayList<>();
            List<KuaiShouVideoGet> customVideos = new ArrayList<>();

            customVideos = videoGetService.getNewVideoBetweenTime(strategy.getAccountId(), startTime, endTime, strategy.getChannelType(), "all", null);
            //2:查询特定素材
            generalVideos = videoGetService.getNewVideoBetweenTime(strategy.getAccountId(), startTime, endTime, strategy.getChannelType(), appInfo.getAppVersion(), null);
            if (Check.isNull(generalVideos) && Check.isNull(customVideos)) {
                log.info("账户：{}，appId({}){}到{}这段时间没有上新素材", strategy.getAccountId(), appInfo.getAppId(), startTime, endTime);
                return new ArrayList<>();
            }
            //合并
            if (null == generalVideos || generalVideos.isEmpty()) {
                return customVideos;
            } else if (null == customVideos || customVideos.isEmpty()) {
                return generalVideos;
            } else {
                generalVideos.addAll(customVideos);
                return generalVideos;
            }
        }
    }

    private List<KuaiShouVideoGet> getRelateZeroVideoList(KuaishouProjectStrategy strategy, String startTime, String endTime, AiKuaiShouAppInfo appInfo, Integer relativeCnt, Long videoCnt) {
        Integer channelType = null;
        if (null != strategy.getChannelType() && strategy.getChannelType() != 2) {
            channelType = strategy.getChannelType();
        }
        return videoGetService.getZeroVideoByParams(strategy.getAccountId(), startTime, endTime, videoCnt, appInfo.getAppVersion(), channelType, relativeCnt);
    }

    private List<KuaiShouVideoGet> getHistoryTopVideoListByParams(KuaishouProjectStrategy strategy, String startTime, String endTime, AiKuaiShouAppInfo appInfo, Long videoCnt) {
        Integer channelType = null;
        if (null != strategy.getChannelType() && strategy.getChannelType() != 2) {
            channelType = strategy.getChannelType();
        }
        return videoGetService.getHistoryTopVideoByParams(strategy.getAccountId(), startTime, endTime, videoCnt, appInfo.getAppVersion(), channelType);
    }

    /**
     * 创建自定义创意
     *
     * @param strategy   账户配置信息
     * @param createType 创意创建类型 1:素材上新 2：历史高质量 3:历史遗漏素材 4：历史素材打捞
     * @param startTime  开始时间
     * @param endTime    结束时间
     */
    @Autowired
    private IKuaiShouCampaignService campaignService;


    private List<KuaiShouVideoGet> getVideosByParams(KuaishouProjectStrategy strategy, String startTime, String endTime, AiKuaiShouAppInfo appInfo, Integer createType, Long videoCnt) {
        if (createType == 1) {
            return getNewVideoListByParams(strategy, startTime, endTime, appInfo);
        } else if (createType == 2) {
            return getHistoryTopVideoListByParams(strategy, startTime, endTime, appInfo, videoCnt);
        } else if (createType == 3) {
            return getRelateZeroVideoList(strategy, startTime, endTime, appInfo, 0, videoCnt);
        } else {  //  type == 4 历史素材打捞
            return getRelateZeroVideoList(strategy, startTime, endTime, appInfo, 20, videoCnt);
        }
    }


    private Long getCampaignId(KuaishouProjectStrategy strategy, CtopOauthToken token, String replaceString, String checkType, Integer createType, Long appId, String uuid) {
        Long campaignId = null;
        if ("ALL_CAMPAIGN".equals(checkType)) {
            campaignId = campaignService.getCampaignIdByAccountAndName(strategy.getAccountId(), replaceString);
        } else if ("TODAY".equals(checkType)) {
            //查询当天创建的计划
            String nowDate = DateUtils.getNowDate("yyyy-MM-dd") + " 00:00:01";
            campaignId = campaignService.getCampaignIdByAccountAndNameAndDate(strategy.getAccountId(), replaceString, nowDate);
        }
        if (!Check.isNull(campaignId)) {
            return campaignId;
        }

        // 不存在“上新”计划，则创建一个计划
        JSONObject campaignParams = new JSONObject();
        campaignParams.put("advertiser_id", token.getAccountId());
        String campaignName = getName(strategy.getCampaignName(), strategy, createType, null, "plan", null, appId, null);
        campaignParams.put("campaign_name", campaignName);
        campaignParams.put("type", strategy.getCampaignType());
        if (null != strategy.getCampaignDayBudget() && strategy.getCampaignDayBudget() != 0) {
            campaignParams.put("day_budget", strategy.getCampaignDayBudget());
        }
        Map<String, Object> campaignCreateResult = kuaishouInterfaceService.campaignCreate(token.getAccessToken(), token.getAccountId(), campaignParams);
        Integer code = (Integer) campaignCreateResult.get("code");
        String message = (String) campaignCreateResult.get("message");
        AiKuaishouCampaignLevelOperationRecord record = new AiKuaishouCampaignLevelOperationRecord(strategy, null, code, message);
        record.setAiStrategyUuid(uuid);
        record.setCampaignName(campaignName);
        record.setCreateType(2);//项目创建

        if (code != 0) {
            log.info("计划创建失败=>message:{}", message);
            record.setCampaignId(0L);
            aiKuaishouCampaignLevelOperationRecordService.saveOrUpdate(record);
            return null;
        }

        campaignId = (Long) campaignCreateResult.get("campaignId");
        record.setCampaignId(campaignId);
        aiKuaishouCampaignLevelOperationRecordService.saveOrUpdate(record);
        Integer campaignStatus = strategy.getCampaignStatus();
        if (!Check.isNull(campaignStatus) && campaignStatus == 2) {
            updateService.updateCampaignStatus(token.getAccessToken(), token.getAccountId(), campaignId, campaignStatus, "yumeng");
        }

        return campaignId;
    }

    private JSONObject createUnitParams(CtopOauthToken token, Long campaignId, KuaishouProjectStrategy strategy, String unitName, Long appId, KuaiShouVideoGet videoItem) {
        // 拼装创建组的入参 json
        JSONObject unitParams = new JSONObject();
        Integer unitType = strategy.getUnitType();
        //创意制作方式
        unitParams.put("unit_type", unitType);
        unitParams.put("advertiser_id", token.getAccountId());
        unitParams.put("campaign_id", campaignId);
        unitParams.put("unit_name", unitName);
        //出价类型
        unitParams.put("bid_type", strategy.getBidType());
        if (!Check.isNull(strategy.getGroupStatus()) && strategy.getGroupStatus() == 2) {
            unitParams.put("put_status", strategy.getGroupStatus());
        }

        //组单日预算
        if (null != strategy.getUnitDayBudget() && strategy.getUnitDayBudget() != 0) {
            unitParams.put("day_budget", strategy.getUnitDayBudget());
        } else {
            unitParams.put("day_budget", 0);
        }
        //应用商店列表
        unitParams.put("ocpx_action_type", strategy.getOcpxActionType());
        //出价
        if (null != strategy.getBid() && "0".equals(strategy.getBid())) {
            Long bid = getBidByString(strategy.getBid());
            unitParams.put("bid", bid);
        }
        if (!Check.isNull(strategy.getCpaBid()) && !"0".equals((strategy.getCpaBid()))) {
            Long cpdBid = getBidByString(strategy.getCpaBid());
            unitParams.put("cpa_bid", cpdBid);
        }
        //优先低成本
        if (null != strategy.getSmartBid() && strategy.getSmartBid() != 0) {
            unitParams.put("smart_bid", strategy.getSmartBid());
        }
        //优化目标
        if (!Check.isNull(strategy.getOcpxActionType())) {
            unitParams.put("ocpx_action_type", strategy.getOcpxActionType());
        }
        //深度转化目标
        if (!Check.isNull(strategy.getDeepConversionType())) {
            unitParams.put("deep_conversion_type", strategy.getDeepConversionType());
        }
        //付费ROI系数
        if (!Check.isNull(strategy.getRoiRatio())) {
            unitParams.put("roi_ratio", strategy.getRoiRatio());
        }
        //深度转化目标出价
        if (!Check.isNull(strategy.getDeepConversionBid())) {
            Long deepConversionBid = getBidByString(strategy.getDeepConversionBid());
            unitParams.put("deep_conversion_bid", deepConversionBid);
        }
        Integer sceneId = null;
        String scenceIdString = strategy.getSceneId();

        if (!Check.isNull(scenceIdString) && !Check.isNull(JSON.parseArray(scenceIdString))) {
            JSONArray scenceArray = JSON.parseArray(scenceIdString);
            sceneId = scenceArray.getInteger(0);
            unitParams.put("scene_id", scenceArray);
        }
        Integer campaignType = strategy.getCampaignType();
        if (campaignType == 2) { // 提升应用安装
            //应用ID
            if (!Check.isNull(appId)) {
                unitParams.put("app_id", appId);
            }
            // 直达链接
            if (!Check.isNull(strategy.getSchemaUri())) {
                unitParams.put("schema_uri", strategy.getSchemaUri());
            }
            // 优先从系统应用商店下载
            if (null != strategy.getUseAppMarket()) {
                unitParams.put("use_app_market", strategy.getUseAppMarket());
            }
            if (null != strategy.getAppStore() && !"".equals(strategy.getAppStore())) {
                unitParams.put("app_store", JSON.parseArray(strategy.getAppStore()));
            }
        } else if (campaignType == 3) { //  获取电商下单
            //url类型
            if (!Check.isNull(strategy.getUrlType())) {
                unitParams.put("url_type", strategy.getUrlType());
            }
            if (!Check.isNull(strategy.getUrl())) {
                unitParams.put("url", strategy.getUrl());
            }
        } else if (campaignType == 5) { //收集销售线索
            //url类型
            if (!Check.isNull(strategy.getWebUriType())) {
                unitParams.put("web_uri_type", strategy.getWebUriType());
            }
            //url
            if (!Check.isNull(strategy.getUrl())) {
                unitParams.put("url", strategy.getUrl());
            }
        } else if (campaignType == 7) { //  提高应用活跃
            //  appId
            if (!Check.isNull(appId)) {
                unitParams.put("app_id", appId);
            }

            //  url
            if (!Check.isNull(strategy.getUrl())) {
                unitParams.put("url", strategy.getUrl());
            }
            //调起链接
            if (!Check.isNull(strategy.getSchemaUri())) {
                unitParams.put("schema_uri", strategy.getSchemaUri());
            }
        }
        //投放开始时间
        if (!Check.isNull(strategy.getBeginTime())) {
            unitParams.put("begin_time", strategy.getBeginTime());
        } else {
            unitParams.put("begin_time", DateUtils.formatDate());
        }
        //投放结束时间
        if (!Check.isNull(strategy.getEndTime())) {
            unitParams.put("end_time", strategy.getEndTime());
        }
        //投放时间段
        if (!Check.isNull(strategy.getScheduleTime())) {
            unitParams.put("schedule_time", strategy.getScheduleTime());
        }
        //转化id
        if (!Check.isNull(strategy.getConvertId())) {
            unitParams.put("convert_id", strategy.getConvertId());
        }
        //创意展现方式
        if (!Check.isNull(strategy.getShowMode())) {
            unitParams.put("show_mode", strategy.getShowMode());
        }
        //投放方式
        if (!Check.isNull(strategy.getSpeed())) {
            unitParams.put("speed", strategy.getSpeed());
        }
        //预约广告
//        if (!Check.isNull(strategy.getSiteType())) {
//            unitParams.put("site_type", strategy.getSiteType());
//        }
        //智能定向
//        if (!Check.isNull(strategy.getAutoTarget())) {
//            unitParams.put("auto_target", strategy.getAutoTarget());
//        }
        //是否开启自动生成视频
//        if (!Check.isNull(strategy.getAutoCreatePhoto())) {
//            unitParams.put("auto_create_photo", strategy.getAutoCreatePhoto());
//        }
        if (unitType == 7) {
            //是否开启智能抽帧
            if (!Check.isNull(strategy.getSmartCover())) {
                unitParams.put("smart_cover", strategy.getSmartCover());
            }
            //程序化创意2.0素材挖掘
//            if (!Check.isNull(strategy.getAssetMining())) {
//                if (strategy.getAssetMining() == 1) {
//                    unitParams.put("asset_mining", true);
//                } else if (strategy.getAssetMining() == 0) {
//                    unitParams.put("asset_mining", false);
//                }
//            }
        }
        if (!Check.isNull(strategy.getTemplateIdArray())) {
            KuaishouDirectionalPackage template = checkTemplateId(strategy.getTemplateIdArray(), videoItem);
            if (Check.isNull(template)) {
                return null;
            }
            Long temId = directionalPackageService.selectTemplateId(template.getId(), token.getAccountId());
            //如果账户没有模板定向，则进行重新推送创建
            if (Check.isNull(temId)) {
                JSONObject jsonObject = JSONObject.parseObject(JSONObject.toJSON(template).toString(), JSONObject.class);
                JSONObject request = new JSONObject();
                request.put("accountId", token.getAccountId());
                directionalPackageService.createDirectionalPackage2(jsonObject, request);
                try {
                    Thread.sleep(200);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
            temId = directionalPackageService.selectTemplateId(template.getId(), token.getAccountId());
            if (!Check.isNull(temId)) {
                if (sceneId != 5) {
                    unitParams.put("template_id", temId); //定向模板id
                } else { // 联盟广告位 需要根据模板id 获取定向数据
                    JSONObject unionJson = groupTemplateService.getUnionJson(temId);
                    Integer code = unionJson.getInteger("code");
                    if (code == 0) {
                        JSONObject target = unionJson.getJSONObject("target");
                        unitParams.put("target", target);
                    } else {
                        log.info("组创建异常=》accountId({})联盟广告位定向模板错误", strategy.getAccountId());
                        return null;
                    }
                }
            }
        } else {
            log.error("定向获取失败");
        }
        return unitParams;
    }

    /**
     * 筛选符合条件的定向
     */
    private KuaishouDirectionalPackage checkTemplateId(String templateIdArray, KuaiShouVideoGet videoItem) {
        List<String> templateIds = JSONObject.parseObject(templateIdArray, List.class);
        List<KuaishouDirectionalPackage> targets = directionalPackageService.getProjectTargetByIds(templateIds);
        if (Check.isNull(targets)) {
            log.error("未获取到定向！");
            return null;
        }
        QueryWrapper<KuaishouVideoDirectionalPackage> queryWrapper = new QueryWrapper();
        queryWrapper.eq("video_get_id", videoItem.getId());
        queryWrapper.last("limit 1");
        KuaishouVideoDirectionalPackage dir = packageMapper.selectOne(queryWrapper);
        if (Check.isNull(dir)) {
            //素材定向为空，随机获取定向
            int i = getrandom(0, targets.size() - 1);
            return targets.get(i);
        } else {
            for (KuaishouDirectionalPackage target : targets) {
                if (!checkList(dir.getRegion(), target.getRegion())) {
                    continue;
                }
                if (!checkList(dir.getDistrictIds(), target.getDistrictIds())) {
                    continue;
                }
                if (!Check.isNull(dir.getUserType()) && dir.getUserType() != 2) {
                    if (dir.getUserType() != target.getUserType()) {
                        continue;
                    }
                }
                if (!checkList(dir.getAgesRange(), target.getAgesRange())) {
                    continue;
                }
                if (!Check.isNull(dir.getMax()) && !Check.isNull(dir.getMin())) {
                    if (Check.isNull(target.getMax()) || Check.isNull(target.getMin())) {
                        continue;
                    }
                    if (dir.getMax() < target.getMin() || dir.getMax() < target.getMin()) {
                        continue;
                    }
                }
                if (!Check.isNull(dir.getGender()) && dir.getGender() != 0) {
                    if (dir.getGender() != target.getGender()) {
                        continue;
                    }
                }
                if (!Check.isNull(dir.getPlatformOs()) && dir.getPlatformOs() != 0) {
                    if (dir.getPlatformOs() != target.getPlatformOs()) {
                        continue;
                    }
                }
                if (!Check.isNull(dir.getAndroidOsv()) && dir.getAndroidOsv() != 3) {
                    if (dir.getAndroidOsv() != target.getAndroidOsv()) {
                        continue;
                    }
                }
                if (!Check.isNull(dir.getIosOsv()) && dir.getIosOsv() != 6) {
                    if (dir.getIosOsv() != target.getIosOsv()) {
                        continue;
                    }
                }
                if (!Check.isNull(dir.getNetwork()) && dir.getNetwork() != 0) {
                    if (dir.getNetwork() != target.getNetwork()) {
                        continue;
                    }
                }
                if (!Check.isNull(dir.getFilterConvertedLevel()) && dir.getFilterConvertedLevel() != 0) {
                    if (dir.getFilterConvertedLevel() != target.getFilterConvertedLevel()) {
                        continue;
                    }
                }
                if (!Check.isNull(dir.getBusinessInterestType()) && dir.getBusinessInterestType() != 0) {
                    if (dir.getBusinessInterestType() != target.getBusinessInterestType()) {
                        continue;
                    }
                }
                if (!checkList(dir.getDeviceBrand(), target.getDeviceBrand())) {
                    continue;
                }
                if (!checkList(dir.getDevicePrice(), target.getDevicePrice())) {
                    continue;
                }
                if (!checkList(dir.getBusinessInterest(), target.getBusinessInterest())) {
                    continue;
                }
                if (!checkList(dir.getFansStar(), target.getFansStar())) {
                    continue;
                }
                if (!checkList(dir.getInterestVideo(), target.getInterestVideo())) {
                    continue;
                }
                if (!checkList(dir.getAppInterest(), target.getAppInterest())) {
                    continue;
                }
                if (!checkList(dir.getAppIds(), target.getAppIds())) {
                    continue;
                }
                if (!Check.isNull(dir.getIsOpen()) && dir.getIsOpen() != 0) {
                    if (dir.getIsOpen() != target.getIsOpen()) {
                        continue;
                    }
                }
                if (!Check.isNull(dir.getNoAgeBreak()) && dir.getNoAgeBreak() != 0) {
                    if (dir.getNoAgeBreak() != target.getNoAgeBreak()) {
                        continue;
                    }
                }
                if (!Check.isNull(dir.getNoGenderBreak()) && dir.getNoGenderBreak() != 0) {
                    if (dir.getNoGenderBreak() != target.getNoGenderBreak()) {
                        continue;
                    }
                }
                if (!Check.isNull(dir.getNoAreaBreak()) && dir.getNoAreaBreak() != 0) {
                    if (dir.getNoAreaBreak() != target.getNoAreaBreak()) {
                        continue;
                    }
                }
                if (!checkList(dir.getKeyword(), target.getKeyword())) {
                    continue;
                }
                if (!checkList(dir.getLabel(), target.getLabel())) {
                    continue;
                }
                if (!checkList(dir.getInterestLabel(), target.getInterestLabel())) {
                    continue;
                }
                if (!checkList(dir.getInterestLabel(), target.getInterestLabel())) {
                    continue;
                }
                if (!checkList(dir.getSceneType(), target.getSceneType())) {
                    continue;
                }
                if (!Check.isNull(dir.getTimeType())) {
                    if (dir.getTimeType() != target.getTimeType()) {
                        continue;
                    }
                }
                if (!Check.isNull(dir.getStrengthType()) && dir.getStrengthType() != 0) {
                    if (dir.getStrengthType() != target.getStrengthType()) {
                        continue;
                    }
                }
                return target;
            }
        }
        return null;
    }

    private boolean checkList(String videoTarget, String target) {
        List videoList = JSONObject.parseObject(videoTarget, List.class);
        if (Check.isNull(videoList)) {
            //素材是不限，直接返回true。
            return true;
        }
        List list = JSONObject.parseObject(target, List.class);
        if (Check.isNull(list)) {
            //计划定向是不限，素材非不限，直接返回false。
            return false;
        }
        for (Object o : list) {
            if (!videoList.contains(o)) {
                return false;
            }
        }
        return true;
    }

    public static int getrandom(int start, int end) {
        int num = (int) (Math.random() * (end - start + 1) + start);
        return num;
    }

    private Long getBidByString(String cpaBid) {
        if (Check.isNull(cpaBid)) {
            return null;
        }
        String bidString = null;
        if (cpaBid.contains("/")) { // 阶梯出价
            String[] split = cpaBid.split("/");
            int random = new Random().nextInt(split.length);
            bidString = split[random];

        } else if (cpaBid.contains("-")) { // 随机出价
            String[] split = cpaBid.split("-");
            Double min = Double.valueOf(split[0]) / 1000;
            Double max = Double.valueOf(split[1]) / 1000;
            Double randomNumber = new BigDecimal(min + Math.random() * (max - min)).setScale(1, BigDecimal.ROUND_HALF_UP).doubleValue();
            bidString = String.valueOf(new Double(randomNumber * 1000).longValue());

        } else {
            bidString = cpaBid;
        }

        return Long.valueOf(bidString);
    }

    private JSONArray cleanPramgramErrorScence(JSONArray scenceArray) {
        JSONArray result = new JSONArray();
        if (null == scenceArray || scenceArray.isEmpty()) {
            return result;
        }
        for (int i = 0; i < scenceArray.size(); i++) {
            Integer senceId = scenceArray.getInteger(i);
            if (senceId != 5 && senceId != 3) {
                result.add(senceId);
            }
        }
        return result;
    }

    private void createCreativeByImage(List<MaterialCutFrame> cutFrameList, CtopOauthToken token, JSONObject creativeParams,
                                       Long campaignId, Long unitId, KuaiShouVideoGet videoItem,
                                       int imageNumber, KuaishouProjectStrategy strategy, String uuid, String appVersion) {
        if ((null != cutFrameList && !cutFrameList.isEmpty())) {
            for (int i = 0; i < cutFrameList.size(); i++) {
                String imageCode = cutFrameList.get(i).getSignature();
                String imageUrl = cutFrameList.get(i).getUrl();
                String imageToken = getImageToken(imageUrl, imageCode, token.getAccountId(), token.getAccessToken());
                creativeParams.put("image_token", imageToken);
                createCreative(token, creativeParams, campaignId, unitId, i + 1, videoItem, strategy, uuid, appVersion);
                imageNumber--;
                if (imageNumber <= 0) {
                    break;
                }
            }
        }
    }

    private String getImageToken(String imageUrl, String imageCode, Long accountId, String token) {
        // 根据imageUrl 和 imageCode，获取 imageToken （创建创意用）
        KuaiShouImageGet imageGet = imageGetService.getOneByParams(null, imageCode);
        if ((null == imageGet) || ("".equals(imageGet.getImageToken()))) {
            /**
             * 如果取不到image_token
             * 则调用上传url的方法 kuauiShouImageUpload(url, signature, accountId, oauthToken.getAccessToken());
             */
            return materialUploadService.kuauiShouImageUpload(imageUrl, imageCode, accountId, token);
        }
        return imageGet.getImageToken();
    }

    private JSONObject creativeParams(CtopOauthToken token, Long unitId, KuaiShouVideoGet videoItem, KuaishouProjectStrategy strategy) {
        JSONObject creativeParams = new JSONObject();
        creativeParams.put("advertiser_id", token.getAccountId());
        creativeParams.put("unit_id", unitId);
        creativeParams.put("photo_id", videoItem.getPhotoId());
        creativeParams.put("creative_material_type", videoItem.getMaterialType());
        creativeParams.put("action_bar_text", strategy.getActionBarText());
        JSONArray descArr = JSONArray.parseArray(strategy.getDescription());
        int index = new Random().nextInt(descArr.size());
        String description = descArr.getString(index);
        creativeParams.put("description", description);
        // 封面广告语标题
        if (!Check.isNull(strategy.getStickerTitle())) {
            creativeParams.put("sticker_title", strategy.getStickerTitle());
        }
        // 贴纸样式类型
        if (!Check.isNull(strategy.getOverlayType())) {
            creativeParams.put("overlay_type", strategy.getOverlayType());
        }
        // 广告标签
        if (!Check.isNull(strategy.getExposeTag())) {
            creativeParams.put("expose_tag", strategy.getExposeTag());
        }
        // 广告标签2期
        if (Check.isNull(strategy.getNewExposeTag())) {
            creativeParams.put("new_expose_tag", JSON.parseArray(strategy.getNewExposeTag()));
        }
        // 安卓下载中间页ID
        if (Check.isNull(strategy.getSiteId())) {
            creativeParams.put("site_id", strategy.getSiteId());
        }
        if (null != strategy.getClickTrackUrl() && !"".equals(strategy.getClickTrackUrl())) {
            creativeParams.put("click_track_url", strategy.getClickTrackUrl());
        }
        if (null != strategy.getImpressionUrl() && !"".equals(strategy.getImpressionUrl())) {
            creativeParams.put("impression_url", strategy.getImpressionUrl());
        }
        // 第三方有效播放监测链接
        if (!Check.isNull(strategy.getAdPhotoPlayedT3sUrl())) {
            creativeParams.put("ad_photo_played_t3s_url", strategy.getAdPhotoPlayedT3sUrl());
        }
        if (null != strategy.getActionbarClickUrl() && !"".equals(strategy.getActionbarClickUrl())) {
            creativeParams.put("actionbar_click_url", strategy.getActionbarClickUrl());
        }
        if (null != strategy.getCreativeCategory()) {
            creativeParams.put("creative_category", strategy.getCreativeCategory());
        }
        if (null != strategy.getCreativeTag() && !"".equals(strategy.getCreativeTag())) {
            creativeParams.put("creative_tag", JSON.parseArray(strategy.getCreativeTag()));
        }
        return creativeParams;
    }


    private void createCreative(CtopOauthToken token, JSONObject creativeParams, Long campaignId, Long unitId,
                                int creativeCnt, KuaiShouVideoGet videoGet, KuaishouProjectStrategy strategy, String uuid, String appVersion) {
        String creativeName = null;
        if (!Check.isNull(appVersion)) {
            creativeName = appVersion + "_" + creativeCnt;
        } else {
            creativeName = "自定义创意_" + creativeCnt;
        }
        creativeParams.put("creative_name", creativeName);
        Map<String, Object> creativeCreateResult = kuaishouInterfaceService.creativeCreate(token.getAccessToken(), token.getAccountId(), creativeParams, 1);
        Integer creativeCode = (Integer) creativeCreateResult.get("code");
        String creativeMessage = (String) creativeCreateResult.get("message");

        if (creativeCode == -1 && "/rest/openapi/v2/creative/create调用已超日限，次日可恢复调用".equals(creativeMessage)) {
            updateService.updateUnitStatus(token.getAccessToken(), token.getAccountId(), unitId, 3, "e9ca23d68d884d4ebb19d07889727dae");
        } else if (creativeCode == -1 && creativeMessage.contains("超过可关联的有效创意的上限")) {
            updateService.updateUnitStatus(token.getAccessToken(), token.getAccountId(), unitId, 3, "e9ca23d68d884d4ebb19d07889727dae");
        } else if (creativeCode == -1 && creativeMessage.contains("视频不存在")) {
            updateService.updateUnitStatus(token.getAccessToken(), token.getAccountId(), unitId, 3, "e9ca23d68d884d4ebb19d07889727dae");
        }

        AiKuaishouCreativeLevelOperationRecord record = new AiKuaishouCreativeLevelOperationRecord();
        BeanUtils.copyProperties(strategy, record);
        record.setCreativeName(creativeName);
        record.setStatus(creativeCode);
        record.setDescription(creativeParams.getString("description"));
        record.setPhotoId(creativeParams.getString("photo_id"));
        record.setMessage(creativeMessage);
        record.setUnitId(unitId);
        record.setAiStrategyUuid(uuid);
        record.setCreateTime(new Date());
        record.setCreateType(2);//项目自动投放
        if (creativeCode != 0) {
            creativeLevelOperationRecordService.saveOrUpdate(record);
            log.info("创意创建失败=>message:{}", creativeMessage);
            return;
        }
        Long creativeId = (Long) creativeCreateResult.get("creativeId");
        record.setCreativeId(creativeId);
        creativeLevelOperationRecordService.saveOrUpdate(record);
    }

    /**
     * @param wildcard 计划名称/组名称
     * @param strategy 账户id
     * @return
     */
    @Autowired
    private RedisUtil redisUtil;
    @Autowired
    private IKuaiShouAppListService appListService;


    /**
     * 通配符命名规则
     * 日期、渠道号、横竖版（视频素材的横版竖版）、时分、广告位置、素材名称、应用包名、创意制作方式（自定义、程序化）
     */
    private String getName(String wildcard, KuaishouProjectStrategy strategy, Integer createType, String materialName, String type, Long campaignId, Long appId, Integer materialType) {
        if (wildcard.contains("{{应用名称}}") || wildcard.contains("{{应用标记}}") || wildcard.contains("{{应用包名}}")) {
            KuaiShouAppList getAppInfo = appListService.getAppInfo(strategy.getAccountId(), appId);
            if (!Check.isNull(getAppInfo)) {
                wildcard = wildcard.replace("{{应用名称}}", getAppInfo.getAppName());
                wildcard = wildcard.replace("{{应用标记}}", getAppInfo.getAppVersion());
                wildcard = wildcard.replace("{{应用包名}}", getAppInfo.getPackageName());
            } else {
                wildcard = wildcard.replace("{{应用名称}}", "");
                wildcard = wildcard.replace("{{应用标记}}", "");
                wildcard = wildcard.replace("{{应用包名}}", "");
            }
        }
        if (wildcard.contains("{{横竖版}}")) {
            if (materialType == 1) {
                wildcard = wildcard.replace("{{横竖版}}", "竖版视频");
            } else if (materialType == 2) {
                wildcard = wildcard.replace("{{横竖版}}", "横版视频");
            } else {
                wildcard = wildcard.replace("{{横竖版}}", "");
            }
        }
        if (wildcard.contains("{{创意制作方式}}")) {
            if (strategy.getUnitType() == 4) {
                wildcard = wildcard.replace("{{创意制作方式}}", "自定义");
            } else if (strategy.getUnitType() == 7) {
                wildcard = wildcard.replace("{{创意制作方式}}", "程序化");
            }
        }
        if (wildcard.contains("{{广告位置}}")) {
            String adsence = getAdSenceByParams(strategy.getSceneId());
            wildcard = wildcard.replace("{{广告位置}}", adsence);
        }

        if (wildcard.contains("{{素材名称}}")) {
            if (Check.isNull(materialName)) {
                wildcard = wildcard.replace("{{素材名称}}", "");
            } else {
                wildcard = wildcard.replace("{{素材名称}}", materialName);
            }
        }
        if (wildcard.contains("{{渠道号}}")) {
            KuaiShouAppMultipleBids multipleBids = kuaiShouAppMultipleBidsService.getInfoByAccountAndAppId(strategy.getAccountId(), appId);
            if (!Check.isNull(multipleBids)) {
                wildcard = wildcard.replace("{{渠道号}}", multipleBids.getChannelCode());
            } else {
                wildcard = wildcard.replace("{{渠道号}}", "");
            }
        }
        if (!wildcard.contains("{{自定义}}")) {
            wildcard = wildcard + "{{自定义}}";
        }
        Date date = new Date();
        String nowDate = DateUtils.formatDate(date, "yy-MMdd");
        if (type.equals("plan")) {
            if (wildcard.contains("{{日期}}")) {
                wildcard = wildcard.replace("{{日期}}", nowDate);
            } else {
                wildcard = wildcard + "-" + nowDate;
            }
        } else if ("unit".equals(type)) {
            wildcard = wildcard.replace("{{日期}}", nowDate);
        }
        String HOUR = DateUtils.formatDate(date, DateUtils.TIME_FORMAT);
        if (wildcard.contains("{{时分}}")) {
            wildcard = wildcard.replace("{{时分}}", HOUR);
        }
        String targetName = KuaishouCreativeMatTypeEnum.getNameByType(strategy.getUnitType().toString() + createType.toString());
        wildcard = wildcard.replace("{{自定义}}", targetName);
        if (!Check.isNull(campaignId)) {
            Integer count = null;
            if (null != strategy.getSingleAppid() && strategy.getSingleAppid() == 2) {
                String redisKey = strategy.getAccountId() + "_" + campaignId;
                Object redisValue = redisUtil.get(redisKey);
                if (Check.isNull(redisValue)) {
                    count = 1;
                    redisUtil.set(redisKey, count);
                } else {
                    count = (Integer) redisValue + 1;
                    redisUtil.set(redisKey, count);
                }
            } else {
                String redisKey = strategy.getAccountId() + "_" + campaignId + nowDate;
                Object redisValue = redisUtil.get(redisKey);
                if (Check.isNull(redisValue)) {
                    count = 1;
                    redisUtil.set(redisKey, count, 100000L);
                } else {
                    count = (Integer) redisValue + 1;
                    redisUtil.set(redisKey, count, 100000L);
                }
            }
            wildcard = wildcard + "-" + count;
        }
        wildcard = wildcard.replace("--", "-");
        if (wildcard.startsWith("-")) {
            wildcard = wildcard.substring(1, wildcard.length());
        }
        if (wildcard.endsWith("-")) {
            wildcard = wildcard.substring(0, wildcard.length() - 1);
        }
        return wildcard;
    }

    private String getAdSenceByParams(String sceneIdString) {
        String adsence = "";
        if (null == sceneIdString || "".equals(sceneIdString)) {
            return adsence;
        }
        JSONArray sceneIdArray = JSON.parseArray(sceneIdString);
        if (null == sceneIdArray || sceneIdArray.isEmpty()) {
            return adsence;
        }
        for (int i = 0; i < sceneIdArray.size(); i++) {
            adsence += KuaishouCreativeAdsenceTypeEnum.getNameByType(sceneIdArray.getInteger(i)) + ",";
        }
        return adsence.substring(0, adsence.length() - 1);
    }


    @Override
    public Boolean getUnitOverrun(String keyx) {
        String nowDate = DateUtils.getNowDate("yyyy-MM-dd");
        String key = keyx + "_" + nowDate + "unit_create_overrun";
        Object redisObj = redisUtil.get(key);
        if (Check.isNull(redisObj)) {
            return false;
        }
        Integer value = (Integer) redisObj;
        if (value == 1) {
            return true;
        } else {
            return false;
        }

    }

}
